/****************************************Copyright (c)**************************************************
**                                      TXRFID
**                                    
**                                 http://www.txrfid.com
**
**--------------ļϢ-------------------------------------------------------------------------
**      : TX_UART.c 
**      : TXRFID
**    : 
**        : ײͨŵͷļ
**
**-----------------޸ļ¼--------------------------------------------------------------
** ޸:    1.

** ǰ汾:    V1.0 
**   :    TXRFID
** ޸:    2009.02.05
** ע    : 
**--------------------------------------------------------------------------------------
**-----------------޸ļ¼--------------------------------------------------------------
** ޸:    1.SetBaud
                2.ȥSerial_Intеʱ

** ǰ汾:    v1.2 
**   :    TXRFID
** ޸:    20090412
** ע    : 
**---------------------------------------------------------------------------------------
**
**-----------------޸ļ¼--------------------------------------------------------------
** ޸:    1.

** ǰ汾:    V2.0 
**   :    TXRFID
** ޸:    2013.06.04
** ע    : 
**--------------------------------------------------------------------------------------

**-----------------------------------------------------------------------------------------
****************************************************************************************/
#define TX_UART_GLOBALS 1
#include "IoDefine.h"
#include "TX_B.h"
#include "TX_UART.h"

//TX522
void SetBaud(void)
{
	uchar i;
	EA = 0;
	SBUF = STX;              		  //0x20,ʮusöģ̽ò
	while(TI == 0);
	TI = 0;
	for(i=150;i>0;i--);	//ʱ 
	SBUF = STX;
	while(TI == 0);	
	TI = 0;


}
/*********************************************************************************************************
** : void Serial_Init(uchar Baud_Num)
** : ڳʼ,趨ڲʣΪMode 1, 8-bit UART, enable receiption
**           ڹڷʽ1һ֡Ϊ10bit1bitʼλ8bit data1bit stop
**           ʿɱ䣬ʣ2/32T1,T1Ϊʷ
**           T1ʣfosc/[12*((2^8)-TH1)]
**
** 䡡: Baud_Num : ʴű0-7
** 0  9600 1 19200 2  28800 3  38400 4  57600 5  115200  6  172800  7 230400 
** עڵƬ⣬֧0  9600 1 19200  2  28800 3  57600 4  57600   
                                 5  57600  6  57600  7 = 57600
**
** 䡡: 
**
** : 
**          
** ȫֱ: 
** ģ: 
**
** : 
** ա: 2005127
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void Serial_Init(uchar Baud_Num)
{	
	PCON = 0x80;              	// SMOD = 1;ʼӱ
	SCON = 0x50;              	// Mode 1, 8-bit UART, ʿɱ䣬enable receiption
	TMOD &= 0x0f;                     // timer1ķʽλȫ0
	TMOD |= 0x20;	      		// Timer 1, mode 2, 8-bit auto reload timer,
	
	ES=0;                        //رմIOж	
	switch(Baud_Num)
	{	
		case 0:	TH1 = BAUD_9600;	break;
		case 1:	TH1 = BAUD_19200;	break;
		case 2:	TH1 = BAUD_28800;	break;
		case 3:	TH1 = BAUD_57600;	break;
		case 4:	TH1 = BAUD_57600;	break;
		case 5:	TH1 = BAUD_57600; break;
		case 6:  TH1 = BAUD_57600; break;
		case 7:  TH1 = BAUD_57600; break;
	}

	CON_485 = 0; 
		
	ET1 = 0;                       // Disable timer1 interrupt
	TR1 = 1;                       // ʼ 

	SetBaud();	             //ģĲ  

    Delay_1ms(100);

	ES = 1;                        // enable uart interrupt
	
}



/*********************************************************************************************************
** :        uchar Send_Data(void)
** : ݻݷ͸TXģ
             ʱ2ΪпڿŹʱSTXʱ2Ϊ10
             ʱ2(10msûнյTXģACK򱾴ʧܡ
**
** 䡡: 
**         
**
** 䡡: 
**
** :
**           
** ȫֱ: 
********************************************************************************************************/
uchar Send_Data(void)
{
	uchar send_len;              //ݳ
	uchar i;

	ES=0;                        //رմIOж
	CON_485=1;           //485λ1
	REN=0;               //ڲ

	SBUF=STX;            //ʼSTXŵݻ
	while(TI==0);        //ѯڷжϱ־λTI,жǷSTX
	TI=0;                //巢жϱ־λ

	send_len=SER_BUFFER[LENGTH]+5;  //Ϊ֮⻹SeqNr,Command,Len,BCCԼETXҪ   
	                                //ԷͳҪݳLENGTHĻϼ5
	SER_BUFFER[send_len-2]=0;       //2ķͻΪBCC0
	SER_BUFFER[send_len-1]=ETX;     //ͻĩΪETX

    //Delay_50us(2);
	for(i=0; i < send_len; i++)//ѭͻݵTXģ
	{
		SBUF=SER_BUFFER[i];
		if(i < (send_len-2))   //BCCУ飬֮ǰݽ
			SER_BUFFER[send_len-2]^=SER_BUFFER[i];
		if(i==send_len-3)    //BCCУ飬֮ǰȡõBCCУ
			SER_BUFFER[send_len-2]=~SER_BUFFER[send_len-2];
		while(TI==0);               //ѯǷһֽ
		TI=0;
	}
	CON_485=0;
	REN=1;                         //
	ES=1;                          //򿪴IOж
	
	return	COMM_OK;               //COMM_OK
}



/*********************************************************************************************************
** :        uchar Serial_Comm(void)
** : TXģ鷢.
             Ϻʱ2Ϊ2120Σ240ڣTXģδӦ
             򱾴ִʧܡ
**
** 䡡: 
**         
**
** 䡡: 
**
** : 
**           
** ȫֱ: 
********************************************************************************************************/
uchar Serial_Comm(void)
{
	uchar ser_wdg=120;             //趨ȴTXģ鷵ݵĳʱ1201202ms=240ms
	if(Send_Data()!=COMM_OK)       //TXģ鷢
	     return COMM_ERR;

	START_T2(RCAP2_2ms);           //򿪲趨ʱ2趨ʱʱΪ2ms
	while(NEW_DATA==0&&ser_wdg!=0) //жϴǷյݻʱʱ
	{
		if(TF2)
		{
			START_T2(RCAP2_2ms);					 //tf
			ser_wdg--;
		}
	} 
	
	if(NEW_DATA)	           //ڽյTXģ鷢
	{	
		NEW_DATA=0;           //ݱ־ΪΪ´ν׼
		return COMM_OK;       //COMM_OK
	}
	else
	{
	    return COMM_ERR;      //240msڶûнյݣ򷵻COMM_ERR
	}
}





/*********************************************************************************************************
** :        void Serial_Int(void)
** : жϺ.ڽյ(STX)ȷACKźţȻټȫ.Ժʱ2Ϊ
             1010ڣδյһֽڣ򱾴νʧܡ
**
** 䡡: 
**         
**
** 䡡: 
**
** : 
**           
** ȫֱ: 
********************************************************************************************************/
void Serial_Int(void) interrupt 4 //using 1 
{
	uchar index;
	uchar BCC_sum=0;
	uchar rcv_len=5;  //Ϊ֮⻹SeqNr,Command,Len,BCCԼETX   
	                  //ԽճҪݳLENGTHĻϼ5 	
	ES=0;             //رմIOж
	RI=0;             //жϱ־λ

	if (SBUF != STX) return;			// жǷΪ֡ͷ

    for(index=0;index<rcv_len;index++)//ѭTXģ鷢͵ݿ
	{
		START_T2(RCAP2_10ms);//򿪲趨ʱ2趨ʱʱΪ10ms,ÿݵĵȴʱΪ10ms
		while(RI==0&&TF2==0);//жϽյݻʱ
		if(RI==1)            //ǽյݶ˳whileѭ
		{	RI=0;        //жϱ־
			SER_BUFFER[index]=SBUF;//յα浽ݻ
			if(index==LENGTH)
			{	
			     rcv_len+=SER_BUFFER[index];//յTXģ鷢͹ݳֵ5
			}
			if(index<rcv_len-2)	
			{
			     BCC_sum^=SER_BUFFER[index];//ݿBCCУ
			}
		}
		else              //еĳݳʱֱ˳
	    {	
			break;
		}
	}
	STOP_T2();               //ֹͣʱ2
	ES=1;                    //򿪴IOж	
	
	if(index==rcv_len)       //жϽյݳǷȷ
	{
		if(BCC_sum!=~SER_BUFFER[rcv_len-2]) //ȷжBCCУǷȷ
		{
			return;   //УBCC
		}
		if(SER_BUFFER[rcv_len-1]!=ETX)	//BCCУȷжǷнETX
		{
			return;
		}
	}
	else	
	{
		return;
	} 
	NEW_DATA=1; //յݸʽȷݱ־λΪ1  
}	



/*********************************************************************************************************
** : void Delay_1ms(uchar num)
** : ʹTimer2ʱʱԼnum  1ms
**
** 䡡: num : ʱ1msı
**         
**
** 䡡: 
**
** : 
**           
** ȫֱ: 
********************************************************************************************************/

void Delay_1ms(uchar num)
{

  RCAP2LH = RCAP2_1ms;       //timer2 auto-reload register set to 1000us
  T2LH    = RCAP2_1ms;       //timer2 register set to 1000us
  ET2 = 0; 	              // Disable timer2 interrupt
  T2CON = 0x04;	              // 16-bit auto-reload, clear TF2, start timer
  
  while (num--)
  {
	while (!TF2);        //ѯT2־
	TF2 = FALSE;         //TF20
  }

  TR2 = FALSE;               //Timer2ֹͣ

}

